rm(list=ls(all=TRUE))
setwd('Z:\\Lobell_Lab')
qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir,'panels_half_deg_area\\compositeSeasonPanelsNAYield_6crop.RData', sep=''))
load(paste(qgdir,'panels_half_deg_area\\fullCompositeSeasonPanelsNAYield_6crop.RData',sep=''))
crops <- names(panels)
nreg <- length(unique(panels[[1]][[1]]$region))
di <- duplicated(orig.panel$Country)
get.avg <- function(crop.i,colmn,yrs=c(1998,2002)) {
  temp <- orig.panel[which(orig.panel$Crop==crops[crop.i]),]
  out <- data.frame(country=orig.panel$FAO_code[!di],value=NA)
  for (i in 1:nrow(out)){
    temp2 <- temp[which(temp$FAO_code==out[i,1]),]
    yeari <- which(temp2$Year>=yrs[1]&temp2$Year<=yrs[2])
    out[i,2] <- mean(temp2[yeari,colmn],na.rm=T)
  }
  if (is.character(colmn))
    names(out)[2] <- colmn
  else
    names(out)[2] <- names(orig.panel)[colmn]
  out
}

save(get.avg, file=paste(qgdir,'output\\6crop\\get.avg.RData',sep=''))


### Regress weather variables on time for each country
countries <- unique(orig.panel$Country)
timeTrend <- list()
for (cntry in countries) {
  timeTrend[[cntry]] <- list()
  timeTrend[[cntry]][['fao_code']] <-
        orig.panel[which(orig.panel$Country==cntry),'FAO_code'][1]
  for (cr in crops) {
    timeTrend[[cntry]][[cr]] <- list()
    timeTrend[[cntry]][[cr]][['CRU']] <- list()
    timeTrend[[cntry]][[cr]][['UDel']] <- list()

    colIndices <- which(names(orig.panel) %in% c('Country', 'Year', 'tAvgUDel',
                                              'tAvgCRU', 'precUDel', 'precCRU'))
    cntryData <- orig.panel[which(orig.panel$Country == cntry &
                orig.panel$Crop == cr), colIndices]
    cntryData$year <- cntryData$Year
    cntryData <- cntryData[cntryData$year >= 1980,]

    # check whether most of a variable's values are NA
    if (length(cntryData[!is.na(cntryData[,'tAvgUDel']),'tAvgUDel']) > nrow(cntryData)/2){
      timeTrend[[cntry]][[cr]][['UDel']][['tavg']] <- lm(tAvgUDel~year, data=cntryData, x=T, y=T)
    } else   timeTrend[[cntry]][[cr]][['UDel']][['tavg']] <- NA

    if (length(cntryData[!is.na(cntryData[,'tAvgCRU']),'tAvgCRU']) > nrow(cntryData)/2){
      timeTrend[[cntry]][[cr]][['CRU']][['tavg']] <- lm(tAvgCRU~year, data=cntryData, x=T,y=T)
    } else  timeTrend[[cntry]][[cr]][['CRU']][['tavg']] <- NA

    if (length(cntryData[!is.na(cntryData[,'precUDel']),'precUDel']) > nrow(cntryData)/2){
      timeTrend[[cntry]][[cr]][['UDel']][['prec']] <- lm(precUDel~year, data=cntryData, x=T, y=T)
    } else  timeTrend[[cntry]][[cr]][['UDel']][['prec']] <- NA

    if (length(cntryData[!is.na(cntryData[,'precCRU']),'precCRU']) > nrow(cntryData)/2){
      timeTrend[[cntry]][[cr]][['CRU']][['prec']] <- lm(precCRU~year, data=cntryData, x=T,y=T)
    } else  timeTrend[[cntry]][[cr]][['CRU']][['prec']] <- NA

    cntryData <- cntryData[cntryData$Year <= 2002,]
    if (length(cntryData[!is.na(cntryData[,'tAvgUDel']),'tAvgUDel']) > nrow(cntryData)/2){
      timeTrend[[cntry]][[cr]][['UDel02']][['tavg']] <- lm(tAvgUDel~year, data=cntryData, x=T, y=T)
    } else timeTrend[[cntry]][[cr]][['UDel02']][['tavg']] <- NA

    if (length(cntryData[!is.na(cntryData[,'precUDel']),'precUDel']) > nrow(cntryData)/2){
      timeTrend[[cntry]][[cr]][['UDel02']][['prec']] <- lm(precUDel~year, data=cntryData, x=T, y=T)
    } else timeTrend[[cntry]][[cr]][['UDel02']][['prec']] <- NA
  }
}

save(timeTrend, file=paste(qgdir,'output\\6crop\\timeTrends.RData',sep=''))

fTrend <- panels

### Detrend data (in both temperature & precip)
for (cr in crops) {
  for (set in names(timeTrend[[1]][[cr]])) {
    fTrend[[cr]][[set]] <- fTrend[[cr]][[set]][which(fTrend[[cr]][[set]]$t >= 1980),]
    tempCountries <- unique(fTrend[[cr]][[set]]$country)
    for (cntry in tempCountries) {
      if (!all(is.na(timeTrend[[cntry]][[cr]][[set]]))) {
        includedYrs <- fTrend[[cr]][[set]][which(fTrend[[cr]][[set]]$country==cntry),'t']
        includedYrs <- includedYrs[includedYrs >= 1980]
        if (set=='UDel02') includedYrs <- includedYrs[includedYrs <= 2002]
        # get the indices in timeTrend corresponding to the included years
        yrIndices <- which(timeTrend[[cntry]][[
          cr]][[set]][['tavg']]$x[,'year'] %in% includedYrs)
        # use the indices to extract the residuals from timeTrend
        tavgResids <- timeTrend[[cntry]][[cr]][[set]][['tavg']]$residuals[yrIndices]
        precResids <- timeTrend[[cntry]][[cr]][[set]][['prec']]$residuals[yrIndices]
        # get tavg and prec values for first year used in f.new
        baseYr <- min(includedYrs)
        baseYrTavg <- timeTrend[[cntry]][[cr]][[set]][['tavg']]$coef[1] +
                      timeTrend[[cntry]][[cr]][[set]][['tavg']]$coef[2]*baseYr
        baseYrPrec <-  timeTrend[[cntry]][[cr]][[set]][['prec']]$coef[1] +
                        timeTrend[[cntry]][[cr]][[set]][['prec']]$coef[2]*baseYr
        # add residuals to baseYr values
        fTrend[[cr]][[set]][which(fTrend[[cr]][[set]]$country == cntry),'tavg'] <-
         baseYrTavg + tavgResids
        fTrend[[cr]][[set]][which(fTrend[[cr]][[set]]$country == cntry),'prec'] <-
          baseYrPrec + precResids
      } else {
        fTrend[[cr]][[set]][which(fTrend[[cr]][[set]]$country == cntry),'tavg'] <- NA
        fTrend[[cr]][[set]][which(fTrend[[cr]][[set]]$country == cntry),'prec'] <- NA
      }
    }
    fTrend[[cr]][[set]]$tavg2 <- (fTrend[[cr]][[set]]$tavg)^2
    fTrend[[cr]][[set]]$prec2 <- (fTrend[[cr]][[set]]$prec)^2
  }
}

### Create two variant datasets:
### 1. Detrended temp, observed precipitation
fTrendTavg <- panels
### 2. Observed temp, detrended precipitation
fTrendPrec <- panels

### Correct the appropriate attributes
for (cr in crops) {
  for (set in names(timeTrend[[1]][[cr]])) {
    endYr <- ifelse(set=='UDel',2008,2002)
    fTrendTavg[[cr]][[set]] <- fTrendTavg[[cr]][[set]][
                                fTrendTavg[[cr]][[set]]$t %in% (1980:endYr),]
    fTrendPrec[[cr]][[set]] <- fTrendPrec[[cr]][[set]][
                                fTrendPrec[[cr]][[set]]$t %in% (1980:endYr),]
    fTrendTavg[[cr]][[set]]$tavg <- fTrend[[cr]][[set]]$tavg
    fTrendPrec[[cr]][[set]]$prec <- fTrend[[cr]][[set]]$prec
    fTrendTavg[[cr]][[set]]$tavg2 <- fTrend[[cr]][[set]]$tavg2
    fTrendPrec[[cr]][[set]]$prec2 <- fTrend[[cr]][[set]]$prec2
  }
}

# Dump some data
rm(list=ls()[which(!ls() %in% c('fTrendTavg', 'fTrendPrec', 'fTrend', 'panels',
                                'qgdir', 'crops', 'nreg'))])

# Load bootstrapped models
load(paste(qgdir,'output\\6crop\\aggregation_fe_boot_tavgIncreaseDeg_6crop_countryxt2.RData',sep=''))


### Create three further sets of predictions:
### 1. predictions with both temp and precipitation de-trended
predTavgPrec = list()
### 2. predictions with de-trended temp, observed precipitation
predTemp = list()
### 3. predictions with observed temp, de-trended precipitation
predPrec = list()


PredictYields <- function(ftemp, bootmodel) {
  startTime <- Sys.time()
  predictions <- list()
  for (cr in crops) {
    #predictions[[cr]] <- list()
    for (set in names(ftemp[[1]])[1]) {
      predictions[[cr]][[set]] <- list()
      for (reg in 1:nreg) {
        # create temporary dataset to traverse and predict from
        data <- ftemp[[cr]][[set]][which(ftemp[[cr]][[set]]$region == reg),]
        use <- which(data$flag==0 & data$country != 'Belgium'
                    & data$country != 'Luxembourg')
        data <- data[use,]
        # create ncountry x 2 arrays
        tempCountries <- unique(data$country)
        tempPred <- array(dim=c(nrow(data), 4,
                              nrow(bootmodel[[1]][[1]][[1]][[1]][['results']])))    # linear, quadratic, year, fao code
        rownames(tempPred) <- data$country
        tempPred[,3,] <- data[,'t']
        tempPred[,4,] <- data[,'fao_code']
        if (all(is.na(bootmodel[[cr]][[set]][[reg]][[1]][[1]]))) {
          predictions[[cr]][[set]][[reg]] <- NA
          next
        }
        for (ordr in 1:2) {
          for (i in 1:nrow(data)) {
            cntry <- data[i,'country']
            if (i == 1 || cntry != data[i-1,'country']) {
              if (all(is.na(bootmodel[[cr]][[set]][[reg]][[ordr]][[1]]))) {
                tempPred[i,ordr,] <- NA
                next
              }
              cf <- bootmodel[[cr]][[set]][[reg]][[ordr]]$results
              # define coefficients used in both linear and quadratic
              intercept <- cf[,paste(cntry)]
              tCoef <- cf[,paste('t:',cntry,sep='')]
              t2Coef <- cf[,paste('t2:',cntry,sep='')]
              tavgCoef <- cf[,'tavg']
              precCoef <- cf[,'prec']
              varArray <- c('t', 't2', 'tavg', 'prec')
              coefArray <- cbind(tCoef, t2Coef, tavgCoef, precCoef)
              # if quadratic, add coefficients used only in quadratic
              if (ordr == 2) {
                tavg2Coef <-cf[,'tavg2']
                prec2Coef <- cf[,'prec2']
                coefArray <- cbind(coefArray, tavg2Coef, prec2Coef)
                varArray <- c(varArray, 'tavg2', 'prec2')
              }
            }
            tempPred[i,ordr,] <- intercept + as.numeric(coefArray%*%as.numeric(data[i,varArray]))
          }
        }
        dimnames(tempPred)[[2]] <- c('linear', 'quadratic', 'year', 'fao_code')
        predictions[[cr]][[set]][[reg]] <- tempPred
      }
    }
  }
  print(Sys.time()-startTime)
  predictions
}

save(PredictYields, file = paste(qgdir,'output\\6crop\\PredictYields.RData',sep=''))

### Predict for both tavg and prec de-trended, then for each alone
predTavgPrec <- PredictYields(fTrend, boot.models)
predTavg <- PredictYields(fTrendTavg, boot.models)
predPrec <- PredictYields(fTrendPrec, boot.models)


### Dump everything here and reload what's needed, or R chokes 
save(predTavgPrec, file=paste(qgdir,'output\\6crop\\predTavgPrec.RData',sep=''))
save(predTavg, file=paste(qgdir,'output\\6crop\\predTavg.RData',sep=''))
save(predPrec, file=paste(qgdir,'output\\6crop\\predPrec.RData',sep=''))
rm(list=ls(all=T))

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir,'panels_half_deg_area\\compositeSeasonPanelsNAYield_6crop.RData', sep=''))
load(paste(qgdir,'output\\6crop\\aggregation_fe_boot_tavgIncreaseDeg_6crop_countryxt2.RData',sep=''))
load(paste(qgdir,'output\\6crop\\PredictYields.RData',sep=''))
crops <- names(panels)
nreg <- length(unique(panels[[1]][[1]]$region))


### Take Rest Of World out of f.new, then predict for original data before detrending
for (cr in crops) {
  for (set in names(panels[[1]])[1]) {
    panels[[cr]][[set]] <- panels[[cr]][[set]][which(panels[[cr]][[set]][,'t']
                                                        >= 1980),]
    panels[[cr]][[set]] <- panels[[cr]][[set]][which(panels[[cr]][[set]][,'country']
                != 'Rest Of World'),]
  }
}

### Predict for original tavg and precip data
predOriginal <- PredictYields(panels, boot.models)

save(predOriginal, file=paste(qgdir,'output\\6crop\\predOriginal.RData',sep=''))

### Dump everything again and reload what's needed
rm(list=ls(all=T))
qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir,'output\\6crop\\predOriginal.RData',sep=''))
crops <- names(predOriginal)
nreg <- length(predOriginal[[1]][[1]])

### Extract differences between observed yields and predicted.
### Yields are converted from logs into original values so that
### differencing makes sense.
yieldDiff <- function(detrended, trended) {
  diff <- list()
  for (cr in crops) {
    diff[[cr]] <- list()
    for (set in names(trended[[1]])) {
      diff[[cr]][[set]] = list()
      for (reg in 1:nreg) {
        if (is.na(detrended[[cr]][[set]][[reg]])) {
          diff[[cr]][[set]][[reg]] = NA
          next
        }
        tmpDiff <- detrended[[cr]][[set]][[reg]]
        for (ordr in 1:2) {
          tmpDiff[,ordr,] <- exp(trended[[cr]][[set]][[reg]][,ordr,]) -
                            exp(detrended[[cr]][[set]][[reg]][,ordr,])
        }
        diff[[cr]][[set]][[reg]] <- tmpDiff
      }
    }
  }
  diff
}

save(yieldDiff, file=paste(qgdir, 'output\\6crop\\yieldDiff.RData',sep=''))

load(paste(qgdir,'output\\6crop\\predTavgPrec.RData',sep=''))
diffTavgPrec <- yieldDiff(predTavgPrec, predOriginal)
save(diffTavgPrec, file=paste(qgdir,'output\\6crop\\diffTavgPrec.RData',sep=''))
rm(list=ls(all=T)) # dump everything again and reload what's needed

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir, 'output\\6crop\\yieldDiff.RData',sep=''))
load(paste(qgdir,'output\\6crop\\predTavg.RData',sep=''))
load(paste(qgdir,'output\\6crop\\predOriginal.RData',sep=''))
crops <- names(predOriginal)
nreg <- length(predOriginal[[1]][[1]])
diffTavg <- yieldDiff(predTavg, predOriginal)
save(diffTavg, file=paste(qgdir,'output\\6crop\\diffTavg.RData',sep=''))
rm(list=ls(all=T))  # dump everything again and reload what's needed

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir, 'output\\6crop\\yieldDiff.RData',sep=''))
load(paste(qgdir,'output\\6crop\\predPrec.RData',sep=''))
load(paste(qgdir,'output\\6crop\\predOriginal.RData',sep=''))
crops <- names(predOriginal)
nreg <- length(predOriginal[[1]][[1]])
diffPrec <- yieldDiff(predPrec, predOriginal)
save(diffPrec, file=paste(qgdir,'output\\6crop\\diffPrec.RData',sep=''))
rm(list=ls(all=T))  # dump everything again and reload what's needed


### Get yield difference ~ year fit. Note that yield difference is in
### hectograms per hector, so that output coefficient of year
### is the yearly change in hg/ha
differenceTrend <- function(yldDff) {
  diffTrend <- list()
  for (cr in crops) {
    avgYield <- get.avg(which(crops==cr), 'Yield')
    diffTrend[[cr]] <- list()
    for (set in names(yldDff[[1]])) {
      diffTrend[[cr]][[set]] = list()
      for (reg in 1:nreg) {
        diffTrend[[cr]][[set]][[reg]] <- list()
        countryNames <- unique(rownames(yldDff[[cr]][[set]][[reg]]))
        diffTrend[[cr]][[set]][[reg]][[1]] <- array(dim=c(length(countryNames),
                                              2, dim(yldDff[[1]][[1]][[1]])[3]))
        dimnames(diffTrend[[cr]][[set]][[reg]][[1]])[[1]] = countryNames
        diffTrend[[cr]][[set]][[reg]][[2]] <- diffTrend[[cr]][[set]][[reg]][[1]]
        for (cntry in countryNames) {
          cntryCode <- yldDff[[cr]][[set]][[reg]][which(rownames(yldDff[[cr
                              ]][[set]][[reg]][,,1])==cntry)[1], 'fao_code',1]
          tmpData <- yldDff[[cr]][[set]][[reg]][which(rownames(yldDff[[cr]][[set]][[reg]][,,1])
                    == cntry),,]
          for (i in 1:(dim(yldDff[[1]][[1]][[1]])[3])) {
            for (ordr in 1:2) {
              if (all(is.na(tmpData[,ordr,i]))) {
                diffTrend[[cr]][[set]][[reg]][[ordr]][cntry,1,i] <- NA
              } else {
                diffTrend[[cr]][[set]][[reg]][[ordr]][cntry,1,i] <-
                  coef(lm(tmpData[,ordr,i]~year, data=data.frame(tmpData[,,i])))[2] #/
                  #avgYield[avgYield[,1]==cntryCode,2] ##
                diffTrend[[cr]][[set]][[reg]][[ordr]][cntry,2,i] <- cntryCode
              }
            }
          }
        }
      }
      dimnames(diffTrend[[cr]][[set]][[reg]][[1]])[[2]] <- c('yield.change', 'fao_code')
      dimnames(diffTrend[[cr]][[set]][[reg]][[2]])[[2]] <- c('yield.change', 'fao_code')
    }
  }
  diffTrend
}

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
save(differenceTrend, file=paste(qgdir,'output\\6crop\\differenceTrend.RData',sep=''))

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir,'output\\6crop\\differenceTrend.RData',sep=''))
load(paste(qgdir,'panels_half_deg_area\\fullCompositeSeasonPanelsNAYield_6crop.RData',sep=''))
load(paste(qgdir,'output\\6crop\\diffTavgPrec.RData',sep=''))
load(paste(qgdir,'output\\6crop\\get.avg.RData',sep=''))
di <- duplicated(orig.panel$Country)
crops <- names(diffTavgPrec)
nreg <- length(diffTavgPrec[[1]][[1]])
diffTrendTavgPrec <- differenceTrend(diffTavgPrec)
save(diffTrendTavgPrec, file=paste(qgdir,'output\\6crop\\diffTrendTavgPrec.RData',sep=''))
rm(list=ls(all=TRUE))

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir,'output\\6crop\\differenceTrend.RData',sep=''))
load(paste(qgdir,'panels_half_deg_area\\fullCompositeSeasonPanelsNAYield_6crop.RData',sep=''))
load(paste(qgdir,'output\\6crop\\diffTavg.RData',sep=''))
load(paste(qgdir,'output\\6crop\\get.avg.RData',sep=''))
di <- duplicated(orig.panel$Country)
crops <- names(diffTavg)
nreg <- length(diffTavg[[1]][[1]])
diffTrendTavg <- differenceTrend(diffTavg)
save(diffTrendTavg, file=paste(qgdir,'output\\6crop\\diffTrendTavg.RData',sep=''))
rm(list=ls(all=TRUE))

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir,'output\\6crop\\differenceTrend.RData',sep=''))
load(paste(qgdir,'panels_half_deg_area\\fullCompositeSeasonPanelsNAYield_6crop.RData',sep=''))
load(paste(qgdir,'output\\6crop\\diffPrec.RData',sep=''))
load(paste(qgdir,'output\\6crop\\get.avg.RData',sep=''))
di <- duplicated(orig.panel$Country)
crops <- names(diffPrec)
nreg <- length(diffPrec[[1]][[1]])
diffTrendPrec <- differenceTrend(diffPrec)
save(diffTrendPrec, file=paste(qgdir,'output\\6crop\\diffTrendPrec.RData',sep=''))
rm(list=ls(all=TRUE))


# Combine regions in all-nation arrays
CombineRegions <- function(diffTrend) {
  allRegions <- list()
  for (cr in 1:length(crops)) {
    avgProd <- get.avg(cr, 'Production')
    avgYld <- get.avg(cr, 'Yield')
    allRegions[[crops[cr]]] <- list()
    for (set in names(diffTrend[[1]])) {
      allRegions[[crops[cr]]][[set]] <- list()
      for (ordr in 1:2) {
        allRegions[[crops[cr]]][[set]][[ordr]] <- list()
        n <- dim(diffTrend[[1]][[1]][[1]][[1]])[3]
        for (i in 1:n) {
          tmpFrame <- c()
          for (reg in 1:nreg) {
            tmpFrame <- rbind(tmpFrame,
                              diffTrend[[crops[cr]]][[set]][[reg]][[ordr]][,,i])
          }
          tmpFrame <- merge(tmpFrame, avgProd, by.x='fao_code',
                            by.y='country', all.x=T, all.y=F)
          tmpFrame <- merge(tmpFrame, avgYld, by.x='fao_code',
                            by.y='country', all.x=T, all.y=F)
          colnames(tmpFrame) <- c('fao_code', 'yield.change', 'production','yield')
          allRegions[[crops[cr]]][[set]][[ordr]][[i]] <- tmpFrame
        }
        tmp <- sapply(1:n,function(x) allRegions[[crops[cr]]][[set]][[ordr]][[x]][,2])
        allRegions[[crops[cr]]][[set]][[ordr]] <- list(
                              li=allRegions[[crops[cr]]][[set]][[ordr]][[1]],
                              mean=allRegions[[crops[cr]]][[set]][[ordr]][[1]],
                              ui=allRegions[[crops[cr]]][[set]][[ordr]][[1]])
        allRegions[[crops[cr]]][[set]][[ordr]][['li']][,'yield.change'] <- apply(tmp,1,quantile,0.05,na.rm=T)
        allRegions[[crops[cr]]][[set]][[ordr]][['ui']][,'yield.change'] <- apply(tmp,1,quantile,0.95,na.rm=T)
        allRegions[[crops[cr]]][[set]][[ordr]][['mean']][,'yield.change'] <- apply(tmp,1,median)
      }
    }
  }
  allRegions
}

qgdir <- 'Z:\\Lobell_Lab\\world_panels\\quantile-grouping\\'
load(paste(qgdir,'panels_half_deg_area\\fullCompositeSeasonPanelsNAYield_6crop.RData',sep=''))
load(paste(qgdir,'output\\6crop\\diffTrendTavgPrec.RData',sep=''))
load(paste(qgdir,'output\\6crop\\diffTrendTavg.RData',sep=''))
load(paste(qgdir,'output\\6crop\\diffTrendPrec.RData',sep=''))
di <- duplicated(orig.panel$Country)
crops <- names(diffTrendTavgPrec)
nreg <- length(diffTrendTavgPrec[[1]][[1]])
load(paste(qgdir,'output\\6crop\\get.avg.RData',sep=''))

diffTrendT.all <- CombineRegions(diffTrendTavg)
diffTrendP.all <- CombineRegions(diffTrendPrec)
diffTrendTP.all <- CombineRegions(diffTrendTavgPrec)

save(diffTrendT.all, diffTrendP.all, diffTrendTP.all,
      file = paste(qgdir,'output\\6crop\\differenceTrends_countryxt2.RData',sep=''))
rm(list=ls())
setwd('Z:/Lobell_Lab/world_panels/quantile-grouping/code/6crop/')
source('figure3.R')